<?php

/***************************************************************************************************
****  LIVE SEARCH  *********************************************************************************
        Adds a live search to the header omni-present across the CMS.
            
        INFO
            Developed by: hcphilly.com
            Date: 2006-09-06

		CHANGELOG
			1.0.3 - Capitialization error was throwing errors, fixed now
			1.0.2 - Now plays nice with other extensions, using $EXT->last_call
			1.0.1 - Fixed a bug with settings being offered even though there aren't any
				  - Fixed a bug where $_GET["S"] wasn't defined
			1.0.0 - INITIAL RELEASE
..................................................................................................*/

class livesearch {
	var $settings		= array();
	
	var $name			= 'Live-search';
	var $version		= '1.0.8';
	var $description	= 'Adds a live search to the top of every CMS page.';
	var $settings_exist	= 'n';
	var $docs_url		= 'http://hcphilly.com';
	
	var $js_heading_set = false;
	
    //
	// Constructor
	//
	function livesearch($settings='')
	{
		$this->settings = $settings;
	}
	
	
	//
	// Add to Database
	//
	function activate_extension ()
	{
        global $DB;
        
        // -- Add edit_field_groups
        $DB->query($DB->insert_string('exp_extensions', array('extension_id' => '',
                                                              'class'        => 'livesearch',
                                                              'method'       => 'add_livesearch',
                                                              'hook'         => 'show_full_control_panel_end',
                                                              'settings'     => '',
                                                              'priority'     => 10,
                                                              'version'      => $this->version,
                                                              'enabled'      => 'y')));
    }

	//
	// Change Settings
	//
	function settings()
	{
		$settings = array();

		$settings['include_entries']		= array('r', array('yes'=>'yes', 'no'=>'no'), 'no');
		$settings['include_comments']		= array('r', array('yes'=>'yes', 'no'=>'no'), 'no');
		$settings['include_files']			= array('r', array('yes'=>'yes', 'no'=>'no'), 'no');
		$settings['include_communication']	= array('r', array('yes'=>'yes', 'no'=>'no'), 'no');
		
		// Complex:
		// [variable_name] => array(type, values, default value)
		// variable_name => short name for setting and used as the key for language file variable
		// type:  t - textarea, r - radio buttons, s - select, ms - multiselect, f - function calls
		// values:  can be array (r, s, ms), string (t), function name (f)
		// default:  name of array member, string, nothing
		//
		// Simple:
		// [variable_name] => 'Butter'
		// Text input, with 'Butter' as the default.

		return $settings;
	}
    
    //
    // Update Extension (by FTP)
    //
    function update_extension($current = '')
    {
        global $DB;
        
        if ($current == '' OR $current == $this->version)
        {
            return FALSE;
        }
        if ($current < '1.0.1' )
        {
            /*Update Query*/
        }
        
        $DB->query("UPDATE exp_extensions SET version = '".$DB->escape_str($this->version)."' WHERE class = 'livesearch'");
    }
    
    //
    // Admin > Field Groups
    //
    function add_livesearch( $out )
	{
		global $DSP, $IN;
		
		global $EXT;
		if($EXT->last_call !== false)
		{
			$out = $EXT->last_call;
		}
		
		$js = "<script type=\"text/javascript\" charset=\"utf-8\">var SESSION='".$IN->GBL('S')."';</script>";
		
		ob_start();
		?>
<script type="text/javascript" charset="utf-8">
	function addLoadEvent(func) {
	  var oldonload = window.onload;
	  if (typeof window.onload != 'function') {
	    window.onload = func;
	  } else {
	    window.onload = function() {
	      if (oldonload) {
	        oldonload();
	      }
	      func();
	    }
	  }
	}
	
	function ajax( url, func )
	{
		req = false;
		// branch for native XMLHttpRequest object
		if(window.XMLHttpRequest) {
			try {
				req = new XMLHttpRequest();
			} catch(e) {
				req = false;
			}
		// branch for IE/Windows ActiveX version
		} else if(window.ActiveXObject) {
			try {
				req = new ActiveXObject("Msxml2.XMLHTTP");
			} catch(e) {
				try {
					req = new ActiveXObject("Microsoft.XMLHTTP");
				} catch(e) {
					req = false;
				}
			}
		}
		if(req) {
			req.onreadystatechange = func;
			req.open("GET", url, true);
			req.send("");
		}
	}
	
	function delegate( that, thatMethod )
    {
        return function() { return thatMethod.call(that); }
    }
	
	function livesearch()
	{
		document.getElementById("livesearch-query").onfocus = function()
		{
			if(this.value == "Live Search")
			{
			    this.value = "";
			}
			
			this.onkeyup();
		}
		document.getElementById("livesearch-query").onblur = function()
		{
			if(this.value == "")
			{
				this.className = "grey";
				this.value = "Live Search";
			}
			
			if(document.getElementById("livesearch-results"))
			{
				document.getElementById("livesearch-results").parentNode.removeChild(document.getElementById("livesearch-results"));
				lastValue = '';
			}
		}
		document.getElementById("livesearch-query").onkeyup = keypressed;
	}
	
	var d = new Date();
	var lastTime = d.getTime();
	var returnLocation = false;
	var lastValue = "";
	function keypressed( e )
	{
	    d = new Date();
		if(d.getTime() > lastTime+100)
		{
		    code = -1;
			if (!e) var e = window.event;
			if (e.keyCode) code = e.keyCode;
			else if (e.which) code = e.which;
			
			if(code == 13 && returnLocation != false)
			{
				window.location = returnLocation;
			}

			if((code == 38 || code == 40) && document.getElementById("livesearch-results"))
			{
				var lis = new Array();
				var ols = document.getElementById("livesearch-results").getElementsByTagName("ol");
				for(var i=0; i<ols.length; i++)
				{
					for(var j=0; j<ols[i].childNodes.length; j++)
					{
						lis.push(ols[i].childNodes[j]);
					}
				}


				if(code == 38)
				{
					selectNext(lis.reverse());
				}
				else if(code == 40)
				{
					selectNext(lis);
				}
			}
            
            var text = document.getElementById("livesearch-query");
			if(text.value != "" && text.value != lastValue)
			{
				text.className = "";
				ajax("/<?php global $PREFS; echo $PREFS->ini('system_folder'); ?>/extensions/ext.livesearch.php?ls_get_query="+text.value, searchresults);
			}
			else if(text.value == "" && document.getElementById("livesearch-results"))
			{
				document.getElementById("livesearch-results").parentNode.removeChild(document.getElementById("livesearch-results"));
			}

			lastValue = text.value;
		}
		lastTime = d.getTime();
	}
	
	function setSelected( li )
	{
		var lis = new Array();
		var ols = document.getElementById("livesearch-results").getElementsByTagName("ol");
		for(var i=0; i<ols.length; i++)
		{
			for(var j=0; j<ols[i].childNodes.length; j++)
			{
				lis.push(ols[i].childNodes[j]);
			}
		}
		
		for(var i=0; i<lis.length; i++)
		{
			if(lis[i] != li)
			{
				lis[i].className = "";
			}
			else
			{
				lis[i].className = "selected";
				returnLocation = lis[i].firstChild.href;
			}
		}
	}
	
	function selectNext( lis )
	{
		var selected = false;
		for(var i=0; i<lis.length; i++)
		{
			if(lis[i].className == "selected" && selected == false)
			{
				lis[i].className = "";
				if(lis[i+1])
				{
					lis[i+1].className = "selected";
					returnLocation = lis[i+1].firstChild.href;
					window.status = returnLocation;
					selected = true;
				}
			}
		}
		
		if(!selected && lis.length > 0)
		{
			lis[0].className = "selected";
			returnLocation = lis[0].firstChild.href;
		}
	}
	
	function searchresults()
	{
		/*
			<ul>			var results
				<li>		var entries
					<ul>	var entries_ul
		*/
		
		if (req.readyState == 4) {
		if (req.status == 200) {
			var dom = req.responseXML;
			
			if(document.getElementById("livesearch-results"))
			{
				document.getElementById("livesearch-results").parentNode.removeChild(document.getElementById("livesearch-results"));
			}
			
			var results = document.createElement("ul");
				results.id = "livesearch-results";
			
			var entry_list = xmlToLi(dom.getElementsByTagName("entries").item(0));
			if(entry_list.length > 0)
			{
				var entries = document.createElement("li");
					results.appendChild(entries);
				var entries_div = document.createElement("div");
					entries.appendChild(entries_div);
				var entries_text = document.createTextNode("Entries");
					entries_div.appendChild(entries_text);
				var entries_ul = document.createElement("ol");
					entries.appendChild(entries_ul);

				for(var i=0; i<entry_list.length; i++)
				{
					entries_ul.appendChild(entry_list[i]);
				}				
			}
			
			var comment_list = xmlToLi(dom.getElementsByTagName("comments").item(0));
			if(comment_list.length > 0)
			{
				var comments = document.createElement("li");
					results.appendChild(comments);
				var comments_div = document.createElement("div");
					comments.appendChild(comments_div);
				var comments_text = document.createTextNode("Comments");
					comments_div.appendChild(comments_text);
				var comments_ul = document.createElement("ol");
					comments.appendChild(comments_ul);

				for(var i=0; i<comment_list.length; i++)
				{
					comments_ul.appendChild(comment_list[i]);
				}
			}
			
			document.body.appendChild(results);
			
			if(results.getElementsByTagName("ol").length > 0)
			{
				if(results.getElementsByTagName("ol").item(0).getElementsByTagName("li").length > 0)
				{
					setSelected(results.getElementsByTagName("ol").item(0).getElementsByTagName("li").item(0));
				}
			}
		} else {
			// alert("There was a problem retrieving the XML data:\n" + req.statusText);
		}
		}
	}
	
	function xmlToLi( nodeList )
	{
		var nodes = new Array();
		
		if(!nodeList) return nodes;
		
		for(var i=0; i<nodeList.childNodes.length; i++)
		{
			var entry = nodeList.childNodes[i];
			var entry_li = document.createElement("li");
			var comment_id = false;
			var entry_id = false;
			var weblog_id = false;
			var title = false;
			
			if(entry.getElementsByTagName("comment_id").length > 0)
			{
				comment_id = entry.getElementsByTagName("comment_id").item(0).firstChild.nodeValue;
			}
			if(entry.getElementsByTagName("weblog_id").length > 0)
			{
				weblog_id = entry.getElementsByTagName("weblog_id").item(0).firstChild.nodeValue;
			}
			if(entry.getElementsByTagName("entry_id").length > 0)
			{
				entry_id = entry.getElementsByTagName("entry_id").item(0).firstChild.nodeValue;
			}
			if(entry.getElementsByTagName("title").length > 0)
			{
				title = entry.getElementsByTagName("title").item(0).firstChild.nodeValue;
			}
			else
			{
				title = "No Title";
			}
			if(weblog_id != false && entry_id != false && title != false)
			{
				href = "?S="+SESSION+"&C=edit";
				if(comment_id != false) href += "&M=edit_comment";
				else href += "&M=edit_entry";
				href += "&weblog_id="+weblog_id;
				href += "&entry_id="+entry_id;
				if(comment_id != false) href += "&comment_id="+comment_id;
				
				var link = document.createElement("a");
					link.href = href;
					link.innerHTML = title;
				entry_li.appendChild(link);
				entry_li.onmouseover = function()
				{
					setSelected(this);
				}
				entry_li.onmousedown = function()
				{
					window.location = this.firstChild.href;
				}
			}
			nodes.push(entry_li);
		}
		
		return nodes;
	}
	
	addLoadEvent(livesearch);
</script>
		<?php
		$js .= ob_get_contents();
        ob_end_clean();
		$out .= $js;
		
		global $LANG, $SESS, $PREFS;
		$cp_theme = (! isset($SESS->userdata['cp_theme']) || $SESS->userdata['cp_theme'] == '') ? $PREFS->ini('cp_theme') : $SESS->userdata['cp_theme']; 
		$img_path = $PREFS->ini('theme_folder_url', 1).'cp_themes/'.$cp_theme.'/images/';
		$new_styles = "
		     #livesearch-query { font-weight:bold; }
             .grey { color:#999; }
             #livesearch-results a { color:#367caf; }
             #livesearch-results a:hover { color: #367caf ; }
             #livesearch-results {
            position:absolute;top:1em;right:29px;margin-top:30px;width:200px;background
            :#e0e8ea;padding:0;list-style:none;text-align:left;color:#367caf;border:1px
            solid #ccc; }
             #livesearch-results div { color:#ADC0CB;font-size:12px;padding:6px
            10px;background: #142129 url(".$img_path."tab_inactive.gif) repeat-x left
            bottom; }
             #livesearch-results ol { margin-left:0; padding-left:0;
            list-style-position:inside; }
             #livesearch-results ol li { padding:3px 5px; }
             /*#livesearch-results ol li:hover,*/
             #livesearch-results ol li.selected {color: #ffffff; background: #96c251; }
             /*#livesearch-results ol li:hover a,*/
             #livesearch-results ol li.selected a { color:#ffffff; }
		";
		$out = preg_replace("/<\/style/", $new_styles."</style", $out);
		
		$xhtml = "&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;<span id=\"livesearch\"><input type=\"text\" accesskey=\"l\" id=\"livesearch-query\" class=\"grey\" name=\"livesearch-query\" value=\"Live Search\" style=\"font-size:7pt;width:200px;\" /></span>\r";
		$out = preg_replace("/(>".$LANG->line('new_tab')."<\/a>)/", "$1".$xhtml, $out);
		
		return $out;
	}
	
}

if(isset($_GET["ls_get_query"]))
{
	define('EXT', 'tricky');
	require_once("../config.php");
	header("Content-type:text/xml");
	
	$livequery = $_GET["ls_get_query"];
	$results = array("entries"=>array(),"comments"=>array(),"files"=>array(),"communication"=>array());
	
	$conn = mysql_connect($conf['db_hostname'], $conf['db_username'], $conf['db_password']);
			mysql_select_db($conf['db_name']);
	
	//
	//	Get searchable fields
	//
	$fields = array();
	$query = mysql_query("SELECT field_id FROM exp_weblog_fields");
	while($field = mysql_fetch_object($query))
	{
		$fields[] = "d.field_id_".$field->field_id;
	}
	
	$r = "<livesearch>\r";
	
	//
	//	Select Entries
	//
	$r .= "\t<entries>\r";
	$query = mysql_query("SELECT t.entry_id, t.weblog_id, t.title FROM exp_weblog_titles AS t, exp_weblog_data AS d WHERE t.entry_id=d.entry_id AND (t.title LIKE '%".mysql_real_escape_string($livequery)."%' OR ".implode(" LIKE '%".mysql_real_escape_string($livequery)."%' OR ", $fields)." LIKE '%".mysql_real_escape_string($livequery)."%') ORDER BY t.entry_date DESC LIMIT 10");
	while($entries = mysql_fetch_assoc($query))
	{
		//$results["entries"][] = array("id"=>$entries->entry_id, "title"=>$entries->title);
		$r .= "\t\t<entry>\r";
		foreach($entries as $key=>$value)
		{
			$r .= "\t\t\t<$key>";
			$r .= (!is_numeric($value)) ? "<![CDATA[": "";
			$r .= (strlen($value) > 25) ? strip_tags(substr(preg_replace("/[\r\n]+\s*/", " / ", $value), 0, 25))."..." : strip_tags($value);
			$r .= (!is_numeric($value)) ? "]]>" : "";
			$r .= "</$key>\r";
		}
		$r .= "\t\t</entry>\r";
	}
	$r .= "\t</entries>\r";
	
	//
	//	Select Comments
	//
	$r .= "\t<comments>\r";
	$query = mysql_query("SELECT c.comment_id, c.entry_id, c.weblog_id, c.comment AS title FROM exp_comments AS c WHERE c.comment LIKE '%".mysql_real_escape_string($livequery)."%' ORDER BY c.comment_date DESC LIMIT 10");
	while($entries = mysql_fetch_assoc($query))
	{
		//$results["entries"][] = array("id"=>$entries->entry_id, "title"=>$entries->title);
		$r .= "\t\t<comment>\r";
		foreach($entries as $key=>$value)
		{
			$r .= "\t\t\t<$key>";
			$r .= (!is_numeric($value)) ? "<![CDATA[": "";
			$r .= (strlen($value) > 25) ? strip_tags(substr(preg_replace("/[\r\n]+\s*/", " / ", $value), 0, 25))."..." : strip_tags($value);
			$r .= (!is_numeric($value)) ? "]]>" : "";
			$r .= "</$key>\r";
		}
		$r .= "\t\t</comment>\r";
	}
	$r .= "\t</comments>\r";
	
	//
	//	Select Files
	//
	
	//
	//	Select Communication
	//
	
	$r .= "</livesearch>";
	$r = preg_replace("/[\r\n]+\s*/", "", $r);
	
	echo $r;
}

?>